program MS_DOS_Emulation;
const
  Bufgr    = 32767;
  Fatgr    = 2047;
  Titel    = ^M^J'MS-DOS-Emulator V1.2 vom 26.8.87'^M^J;
  Befehle1 = 'Befehle: Change, Dir, Erase, Help, New,';
  Befehle2 = ^M^J'         Protocol, Quit, Read, Write';
  Nofile   = 'No File';
  Copying  = '- Copying :';
  Diskfull = 'Error : Disk Full';
type
  Tbuff     = array[0..1023] of byte;
  String14  = string[14];
  Anystring = string[255];
var
  Fatbuf                 :array[0..Fatgr] of byte;
  Datbuf                 :array[0..Bufgr] of byte;
  Dirbuf                 :Tbuff;
  Dirsec,Diroff,Bufcl    :integer;
  Psize,Clsize,Dirstart,
  Datstart,Reservsec,
  Eintraege,Sektoren,
  Fatsecs,Secptrk,
  Heads,Maxclnum         :integer;
  Secpcl,Fatzahl,Medium  :byte;
  Msname                 :String14;
  Startgruppe,Datum,Zeit :integer;
  Datlength              :real;
  Cpmname                :String14;
  Datei                  :file;
  Cpmlength,Cpmdate,
  Cpmtime                :integer;
  Msdrive,Cpmdrive,
  Logdrive,I             :byte;
  Befehl                 :Anystring;
  Cmd                    :char;
  Suchname               :String14;
  Gefunden,Exit,Print    :boolean;

{$I C30MSDOS.IN0} {Utilities}
{$I C30MSDOS.IN1} {MS-DOS Diskette lesen}
{$I C30MSDOS.IN2} {MS-DOS Diskette schreiben}
{$I C30MSDOS.IN3} {MS-DOS Erase und Rename}

procedure Conout(Ch :char); external $339;
procedure Lstout(Ch :char); external $32F;

procedure Co(Ch :char);
begin
  Conout(Ch);
  Lstout(Ch)
end;

procedure Help;

  procedure Waittaste;
  var
    Ch :char;
  begin
    write('Beliebige Taste betaetigen ');
    read(kbd,Ch);
    write(^M,'':30)
  end;

begin
  writeln(Titel,Befehle1,Befehle2);
  write(^M^J'Befehle bestehen generell aus einem Buchstaben. Zum',
  ' Teil benoetigen'^M^J'sie ein oder zwei Dateinamen, die',
  ' bereits beim Aufruf angegeben werden'^M^J'koennen, aber ',
  'nicht muessen; fehlende Namen werden explizit abgefragt.',
  ^M^J'Zwischen dem Befehlsbuchstaben und dem ersten Datei',
  'namen braucht'^M^J'kein Leerzeichen zu stehen.'^M^J,
  ^M^J'Es existieren folgende Befehle :'^M^J,
  ^M^J'C : CHANGENAME, besser bekannt als RENAME. Werden',
  ' Dateinamen'^M^J'    angegeben, ist der erste der alte',
  ' und der zweite der neue.'^M^J'    Wildcards sind in',
  ' keinem der beiden Namen erlaubt.'^M^J,
  ^M^J'D : DIRECTORY gibt das Directory der MSDOS-Diskette',
  ' aus. Wildcards'^M^J'    sind erlaubt, ausserdem kann',
  ' durch Eingabe eines ''F'' unmittelbar'^M^J'    nach dem',
  ' Befehl die Option ''FULL'' gesetzt werden, die fuer alle',
  ^M^J'    Files die Dateilaenge sowie Datum- und Zeiteintrag',
  ' ausgibt. Ohne'^M^J'    Angabe eines Dateinamens werden',
  ' alle Files angezeigt.'^M^J^J);
  Waittaste;
  write(^M'E : ERASE loescht das angegebene File. Wildcards sind',
  ' erlaubt.'^M^J,
  ^M^J'H : HELP, augenblicklich aktiver Programmteil.'^M^J,
  ^M^J'Q : QUIT, Ausgang zum Betriebssystem CP/M.'^M^J,
  ^M^J'R : READ, Datei(en) von MSDOS lesen und nach CP/M',
  ' schreiben. Quell-'^M^J'    und Zielname duerfen verschie',
  'den sein (zwei Namen angeben);'^M^J'    ansonsten wird',
  ' die Datei unter gleichem Namen kopiert.'^M^J'    Bei Wi',
  'ldcards werden die Dateinamen von MSDOS uebernommen.',
  ^M^J'    Da unter CP/M die Dateilaengen nur Vielfache von',
  ' 128 sein'^M^J'    koennen, werden die Dateien beim Kopie',
  'ren in der Regel'^M^J'    etwas laenger; ausserdem muessen',
  ' u.U. Dateiendezeichen (1Ah)'^M^J'    angefuegt werden.'^M^J,
  ^M^J'W : WRITE, Datei(en) von CP/M lesen und nach MSDOS',
  ' schreiben.'^M^J'    Die Namen werden wie bei READ angege',
  'ben, bei Wildcards wie immer'^M^J'    der CP/M-Name',
  ' uebernommen.'^M^J^J)
end;

begin
  Print:=false;
  writeln(Titel,Befehle1,Befehle2);
  repeat
    write(^M^J'Laufwerk mit MS-DOS-Diskette : ');
    readln(Befehl);
    Msdrive:=ord(upcase(Befehl[1]))-$41
  until Msdrive = 5;
  repeat
    write('Laufwerk mit CP/M - Diskette : ');
    readln(Befehl);
    Cpmdrive:=ord(upcase(Befehl[1]))-$41
  until Cpmdrive in [1..3];
  writeln('Hinweis: phys. Disk-Parameter muessen korrekt gesetzt sein !'^M^J);
  Logdrive:=bdos(25);
  Mslogin;
  repeat
    repeat
      write('MSDOS>');
      readln(Befehl)
    until length(Befehl) > 0;
    for I:=1 to length(Befehl) do Befehl[I]:=upcase(Befehl[I]);
    Cmd:=Befehl[1];
    Exit:=Cmd = 'Q';
    delete(Befehl,1,1);
    while (length(Befehl) > 0) and (Befehl[1] = ' ') do delete(Befehl,1,1);
    case Cmd of
      'C' : Rename;
      'D' : Directory;
      'E' : Erase;
      'H' : Help;
      'N' : Mslogin;
      'P' : begin
              Print:=not Print;
              if Print then conoutptr:=addr(Co)
              else conoutptr:=addr(Conout)
            end;
      'Q' : ;
      'R' : Readfile;
      'W' : Writefile
      else writeln(^G,Cmd,'?')
    end
  until Exit;
  Relog(Logdrive)
end.
