
procedure SchnittstellenInit(SioCode :byte);
begin
  Inline(
                   {         CSEG                                              }
  $21/*+144/       {         LD      HL,SERTAB       ;TABELLENZEIGER           }
  $3A/SIOCODE/     {         LD      A,(SIOCODE)     ;INITCODE VON TURBO       }
  $5F/             {         LD      E,A                                       }
  $CB/$43/         {         BIT     0,E             ;TEST AUF 300 BAUD        }
  $20/$0B/         {         JR      NZ,B75_12       ;SPRINGE WENN NEIN        }
  $CD/*+101/       {         CALL    TX                                        }
  $2B/             {         DEC     HL                                        }
  $CD/*+111/       {         CALL    RX                                        }
  $18/$1C/         {         JR      SIOINT                                    }
  $CB/$4B/         { B75_12: BIT     1,E             ;TEST AUF 75/1200 BD      }
  $20/$0B/         {         JR      NZ,B12_75       ;NEIN-> 1200/75 BD        }
  $23/             {         INC     HL              ;TABELLENZEIGER           }
  $23/             {         INC     HL              ;SETZEN                   }
  $CD/*+84/        {         CALL    TX                                        }
  $23/             {         INC     HL                                        }
  $CD/*+96/        {         CALL    RX                                        }
  $18/$0D/         {         JR      SIOINT                                    }
  $23/             { B12_75: INC     HL                                        }
  $23/             {         INC     HL                                        }
  $23/             {         INC     HL                                        }
  $23/             {         INC     HL                                        }
  $CD/*+71/        {         CALL    TX                                        }
  $2B/             {         DEC     HL                                        }
  $2B/             {         DEC     HL                                        }
  $2B/             {         DEC     HL                                        }
  $CD/*+81/        {         CALL    RX                                        }
  $3E/$19/         { SIOINT: LD      A,00011001B     ;RESET SIOWRITEREG 1      }
  $D3/$96/         {         OUT     (SIOAC),A                                 }
  $3E/$00/         {         LD      A,0             ;DATEN SIOWRITEREG 1      }
  $D3/$96/         {         OUT     (SIOAC),A                                 }
  $3E/$03/         {         LD      A,3             ;ANWAHL SIOWRITEREG 3     }
  $D3/$96/         {         OUT     (SIOAC),A       ;FUER EMPFANGSBEDING.     }
  $3E/$61/         {         LD      A,01100001B     ;RX ENABLE, 7BIT/CHAR     }
  $CB/$7B/         {         BIT     7,E             ;TEST AUF 8BIT/CHAR       }
  $20/$02/         {         JR      NZ,BYT7R                                  }
  $CB/$FF/         {         SET     7,A                                       }
  $D3/$96/         { BYT7R:  OUT     (SIOAC),A                                 }
  $3E/$05/         {         LD      A,5             ;ANWAHL SIOWRITEREG 5     }
  $D3/$96/         {         OUT     (SIOAC),A       ;FUER SENDEBEDINGUNGEN    }
  $3E/$AA/         {         LD      A,10101010B     ;TX ENABLE,RTS,7BIT/CHAR  }
  $CB/$7B/         {         BIT     7,E             ;TEST AUF 8BIT/CHAR       }
  $20/$02/         {         JR      NZ,BYT7T                                  }
  $CB/$F7/         {         SET     6,A                                       }
  $D3/$96/         { BYT7T:  OUT     (SIOAC),A                                 }
  $3E/$04/         {         LD      A,4             ;ANWAHL SIOWRITEREG 4     }
  $D3/$96/         {         OUT     (SIOAC),A                                 }
  $3E/$44/         {         LD      A,01000100B     ;1 STOPBIT,NOPAR          }
  $CB/$73/         {         BIT     6,E             ;TEST AUF 2 STOPBITS      }
  $20/$02/         {         JR      NZ,STOP1                                  }
  $CB/$DF/         {         SET     3,A                                       }
  $CB/$6B/         { STOP1:  BIT     5,E             ;TEST AUF PARITAET EIN    }
  $20/$08/         {         JR      NZ,PARNOD                                 }
  $CB/$C7/         {         SET     0,A                                       }
  $CB/$63/         {         BIT     4,E             ;TEST AUF EVEN PARITAET   }
  $20/$02/         {         JR      NZ,PARNOD                                 }
  $CB/$CF/         {         SET     1,A                                       }
  $D3/$96/         { PARNOD: OUT     (SIOAC),A                                 }
  $C9/             {         RET                                               }
                   {  EINSTELLUNG DES SENDER-BAUDRATEN-GENERATORS              }
  $7E/             { TX:     LD      A,(HL)          ;TIMER B DATEN            }
  $D3/$8A/         {         OUT     (STIA),A                                  }
  $23/             {         INC     HL                                        }
  $7E/             {         LD      A,(HL)          ;FREQUENZVORTEILER-DATEN  }
  $E6/$0F/         {         AND     0FH                                       }
  $47/             {         LD      B,A                                       }
  $DB/$89/         {         IN      A,(STI9)                                  }
  $E6/$F0/         {         AND     0F0H                                      }
  $B0/             {         OR      B                                         }
  $D3/$89/         {         OUT     (STI9),A                                  }
  $C9/             {         RET                                               }
                   {  EINSTELLUNG DES EMPFAENGER-BAUDRATEN-GENERATORS          }
  $7E/             { RX:     LD      A,(HL)          ;TIMER A DATEN            }
  $D3/$8B/         {         OUT     (STIB),A                                  }
  $23/             {         INC     HL                                        }
  $7E/             {         LD      A,(HL)          ;FREQUENZVORTEILER-DATEN  }
  $E6/$F0/         {         AND     0F0H                                      }
  $47/             {         LD      B,A                                       }
  $DB/$89/         {         IN      A,(STI9)                                  }
  $E6/$0F/         {         AND     0FH                                       }
  $B0/             {         OR      B                                         }
  $D3/$89/         {         OUT     (STI9),A                                  }
  $C9/             {         RET                                               }
  $40/             { SERTAB: DEFB    64              ;300  BAUD                }
  $11/             {         DEFB    11H                                       }
  $40/             {         DEFB    64              ;75   BAUD                }
  $33/             {         DEFB    33H                                       }
  $10/             {         DEFB    16              ;1200 BAUD                }
  $11/             {         DEFB    11H                                       }
  $00)
end;

