*       VDISK --- installiert eine Ramdisk mit 512 kByte

*       VDISK <numwert>  (per TTP oder Autoexec.BAT)
*                 installiert eine Ramdisk mit der Groesse <numwert>

GEMDOS  EQU     1
XBIOS   EQU     14
PRT     EQU     9
KEEP    EQU     $31
HITPA   EQU     4
BASPAG  EQU     4
COMMAND EQU     $80
LF      EQU     10
CR      EQU     13
ESC     EQU     $1B
KBYTE   EQU     $400
HDVBPB  EQU     $472
HDVRW   EQU     $476
HDVMED  EQU     $47E
DRVBITS EQU     $4C2

        TEXT
        BRA     INSTALL
CLEAR   LEA     RAMDISK(PC),A0
        MOVE    #DATSTRT(PC),D1
        MULU    #$80,D1
        SUBQ    #1,D1
CLRLP   CLR.L   (A0)+
        DBF     D1,CLRLP
        TRAP    #GEMDOS

DRVNUM  DS.W    1
OLDBPB  DS.L    1
OLDRW   DS.L    1
OLDMED  DS.L    1
RAMBPB  DC.W    $0200
RAMCLST DC.W    0001
BPCL    DC.W    $0200
DIRSIZ  DC.W    0004
FATSIZ  DC.W    0006
FA2BEG  DC.W    0007
DATSTRT DC.W    $0011
DATSIZ  DC.W    0000
FLAGS   DC.W    0001
RESV    DC.W    $000A

NEWBPB  MOVE    4(SP),D0
        MOVE.L  OLDBPB(PC),A0
        LEA     RDBPB(PC),A1
        BRA     CHKDRIV
NEWRW   MOVE    14(SP),D0
        MOVE.L  OLDRW(PC),A0
        LEA     RDRW(PC),A1
        BRA     CHKDRIV
NEWMED  MOVE    4(A7),D0
        MOVE.L  OLDMED(PC),A0
        LEA     RDMED(PC),A1
CHKDRIV CMP     DRVNUM,D0
        BNE     OLDDISK
        JMP     (A1)
OLDDISK JMP     (A0)

RDRW    MOVE    10(A7),D1
        MULU    #$20,D1
        MOVE.L  6(SP),A0
        MOVE.L  A0,D2
        LEA     RAMDISK(PC),A1
        MOVE    $C(SP),D0
        MULU    #$200,D0
        ADD.L   D0,A1
        TST     4(SP)
        BNE     RDWRITE
        EXG     A1,A0
RDWRITE BTST    #0,D2
        BNE     ODD
        SUBQ.L  #1,D1
TLONG   MOVE.L  (A0)+,(A1)+
        MOVE.L  (A0)+,(A1)+
        MOVE.L  (A0)+,(A1)+
        MOVE.L  (A0)+,(A1)+
        DBF     D1,TLONG
RDMED   CLR.L   D0
        RTS
ODD     ASL.L   #2,D1
        SUBQ.L  #1,D1
TBYTE   MOVE.B  (A0)+,(A1)+
        MOVE.B  (A0)+,(A1)+
        MOVE.B  (A0)+,(A1)+
        MOVE.B  (A0)+,(A1)+
        DBF     D1,TBYTE
        BRA     RDMED
RDBPB   MOVE.L  #RAMBPB,D0
        RTS

RAMDISK DC.W    1
SAFEST  DC.W    128

INSTALL MOVE.L  SP,A5
        MOVE.L  BASPAG(A5),A5
        MOVE.L  #0,DSIZE
GETSIZE MOVE.L  HITPA(A5),D7
        SUB.L   #RAMDISK,D7
        DIVU    #KBYTE,D7
        SUB     SAFEST,D7
        CMP     #$10,D7
        BLT     NOSTOR
        LEA     COMMAND(A5),A0
        BSR     ANAL
        TST     D0
        BNE     TAKEIT
        MOVE    #$200,D0
TAKEIT  CMP     D7,D0
        BLE     OK
        MOVE    D7,D0
OK      CMP     RESV,D0
        BLT     NOSTOR
        MOVE    DO,D7
        MOVE.L  #SETVEC,-(SP)
        MOVE    #38,-(SP)
        TRAP    #XBIOS
        ADDQ.L  #6,SP
        MOVE    D7,D0
        BSR     PUTNUM
        LEA     INSTMSG(PC),A0
        BSR     PRTS
        MULU    #2,D7
        MOVE    D7,D1
        SUB     DATSTRT,D1
        MOVE    D1,DATSIZ
        MULU    #$200,D7
        ADD.L   #$258,D7
        MOVE    #0,-(SP)
        MOVE.L  D7,-(SP)
        MOVE    #KEEP,-(SP)
        CLR.L   D0
        BRA     CLEAR

SETVEC  MOVE    #2,D1
        MOVE.L  DRVBITS,D0
NXTBIT  ADDQ    #1,D1
        BSET    D1,D0
        BNE     NXTBIT
        MOVE.L  D0,DRVBITS
        MOVE    D1,DRVNUM
        ADD.B   D1,DRVM2
        MOVE.L  HDVBPB,OLDBPB
        MOVE.L  HDVRW,OLDRW
        MOVE.L  HDVMED,OLDMED
        MOVE.L  #NEWBPB,HDVBPB
        MOVE.L  #NEWRW,HDVRW
        MOVE.L  #NEWMED,HDVMED
        RTS

NOSTOR  LEA     NOMSG(PC),A0
        BSR     PRTS
        MOVE    #0,-(SP)
        TRAP    #GEMDOS

ANAL    SUB.L   D0,D0
        SUB.L   D2,D2
        MOVE.B  (A0)+,D0
        BEQ     RETA
CONV    MOVE    D0,D1
        SUBQ    #1,D1
CLP     MOVE.B  (A0)+,D0
        SUB.B   #'0',D0
        BMI     NOVAL
CONV1   CMP     #9,D0
        BGT     NOVAL
        MULU    #10,D2
        ADD     D0,D2
NOVAL   DBF     D1,CLP
RETA1   MOVE    D2,D0
RETA    RTS

PUTCHAR MOVE    D0,-(SP)
        MOVE    #2,-(SP)
        TRAP    #GEMDOS
        ADDQ.L  #4,SP
        RTS

PUTNUM  CMP     #$9,D0
        BLE     ISNUM
        MOVE    D0,-(SP)
        EXT.L   D0
        DIVU    #$A,D0
        JSR     PUTNUM
        MOVE    (SP)+,D0
ISNUM   EXT.L   D0
        DIVU    #$A,D0
        SWAP    D0
        ADD     #$30,D0
        JMP     PUTCHAR

PRTS    MOVE.L  A0,-(SP)
        MOVE    #9,-(SP)
        TRAP    #GEMDOS
        ADDQ.L  #6,SP
        RTS

INSTMSG DC.B    ' kByte VDISK als Drive '
DRVM2   DC.B    'A: installiert',CR,LF,0
NOMSG   DC.B    CR,LF,'Ramdisk nicht installiert !',0

        .EVEN
DSIZE:  DS.L    1
        .END
