program Dame;
const
  Gegner   = 2;
  DefStart = 3;
  Maxzt    = 8;
  Ziel     :array[1..2] of integer = (7,0);
  Stein    :array[1..2,0..7] of integer = ((0,0,1,1,2,2,4,50),(50,4,2,2,1,1,0,0));
  St_wert  = 10;
  Da_wert  = 50;
  Zu_wert  = 1;
type
  Sp_br = array[0..7,0..7] of byte;
  Ztyp  = array[0..Maxzt] of record
                               X,Y :integer
                             end;
  Zlist = array[0..50] of Ztyp;
var
  Brett          :Sp_br;
  Beta_anz,
  Alpha_anz,
  Ges_anz,
  Verl,
  Amz,
  Xp,Yp,Xap,Yap,
  Start,
  Za             :integer;
  Mi             :Ztyp;
  C              :char;

procedure Set_Rub;
begin
  write(#27#27'C4');
  write(#27#27'J'#$7F);
  write(#27#27'F');
  write('FFFFFFFFFFFFFFFF'#13);
  write(#27#27'C0')
end;

procedure Cur_Off;
begin
  write(#27'.0')
end;

procedure Cur_On;
begin
  write(#27'.2')
end;

procedure Set_Brett;
var
  I,J :integer;
begin
  for I:=0 to 7 do
  begin
    for J:=0 to 7 do
    begin
      Brett[I,J]:=0;
      if (8*I+J < 24) and ((9*I+J) mod 2 = 1) then Brett[I,J]:=1;
      if (8*I+J >= 40) and ((9*I+J) mod 2 = 1) then Brett[I,J]:=2
    end
  end
end;

procedure Out_Brett;
var
  I,J :integer;
  F   :char;
begin
  gotoxy(4,1);
  for I:=0 to 7 do write(' ',chr(65+I),' ');
  writeln;
  for I:=0 to 7 do
  begin
    write(8-I:2,' ');
    for J:=0 to 7 do
    begin
      if (9*I+J) mod 2 = 1 then F:=#$7F else F:=' ';
      case Brett[I,J] of
        0 :write(F,F,F);
        1 :write(F,'o',F);
        2 :begin
             write(F);
             normvideo;
             write('o');
             lowvideo;
             write(F)
           end;
        3 :write(F,'x',F);
        4 :begin
             write(F);
             normvideo;
             write('x');
             lowvideo;
             write(F)
           end
      end
    end;
    writeln
  end
end;

procedure Ch_to_Dame(I,J :integer);
begin
  if Amz = 1 then
  begin
    if (I = 7) and (Brett[7,J] = 1) then Brett[7,J]:=3
  end
  else
  begin
    if (I = 0) and (Brett[0,J] = 2) then Brett[0,J]:=4
  end
end;

procedure New_Zug(var G,T,I,J :integer; var Zuege :Zlist; var Schlag :boolean);
begin
  if G = 1 then
  begin
    T:=succ(T);
    Zuege[T,0].X:=I;
    Zuege[T,0].Y:=J;
    Schlag:=true
  end
end;

procedure Dam_Zug(var T,I,J,X,Y :integer; var Zuege :Zlist);
begin
  T:=succ(T);
  Zuege[T,0].X:=I;
  Zuege[T,0].Y:=J;
  Zuege[T,1].X:=X;
  Zuege[T,1].Y:=Y;
  Zuege[T,2].X:=-1
end;

procedure Copy_Zug(var G,St,T :integer; var Zuege :Zlist);
var
  A :integer;
begin
  if (G > 1) and (St > 0) then
  begin
    for A:=0 to G-1 do Zuege[T+1,A]:=Zuege[T,A];
    T:=succ(T)
  end
end;

{$A-}
procedure Test_Dame(F,I,J,G :integer; var T :integer; var Zuege :Zlist; var Schlag :boolean);
var
  R,Rd,X,Y,Z,St :integer;
begin
  St:=0;
  R:=1+((F-2) mod 2);
  Rd:=2+R;
  X:=I+1; Y:=J+1;
  if G = 1 then Brett[I,J]:=0;
  while (X <= 7) and (Y <= 7) and (Brett[X,Y] <> F-2) and (Brett[X,Y] <> F) do
  begin
    if not Schlag and (G = 1) and (Brett[X,Y] = 0) then
    begin
      Dam_Zug(T,I,J,X,Y,Zuege)
    end
    else if (X < 7) and (Y < 7) and ((Brett[X,Y] = R) or (Brett[X,Y] = Rd)) then
         begin
           if Brett[X+1,Y+1] <> 0 then X:=8
           else
           begin
             New_Zug(G,T,I,J,Zuege,Schlag);
             Copy_Zug(G,St,T,Zuege);
             Zuege[T,G].X:=X+1;
             Zuege[T,G].Y:=Y+1;
             Zuege[T,G+1].X:=-1;
             Z:=Brett[X,Y];
             Brett[X,Y]:=0;
             Test_Dame(F,X+1,Y+1,G+1,T,Zuege,Schlag);
             Brett[X,Y]:=Z;
             St:=succ(St);
             X:=8
           end
         end;
    X:=succ(X); Y:=succ(Y)
  end;
  X:=I+1; Y:=J-1;
  while (X <= 7) and (Y >= 0) and (Brett[X,Y] <> F-2) and (Brett[X,Y] <> F) do
  begin
    if not Schlag and (G = 1) and (Brett[X,Y] = 0) then
    begin
      Dam_Zug(T,I,J,X,Y,Zuege)
    end
    else if (X < 7) and (Y > 0) and ((Brett[X,Y] = R) or (Brett[X,Y] = Rd)) then
         begin
           if Brett[X+1,Y-1] <> 0 then X:=8
           else
           begin
             New_Zug(G,T,I,J,Zuege,Schlag);
             Copy_Zug(G,St,T,Zuege);
             Zuege[T,G].X:=X+1;
             Zuege[T,G].Y:=Y-1;
             Zuege[T,G+1].X:=-1;
             Z:=Brett[X,Y];
             Brett[X,Y]:=0;
             Test_Dame(F,X+1,Y-1,G+1,T,Zuege,Schlag);
             Brett[X,Y]:=Z;
             St:=succ(St);
             X:=8
           end
         end;
    X:=succ(X); Y:=pred(Y)
  end;
  X:=I-1; Y:=J+1;
  while (X >= 0) and (Y <= 7) and (Brett[X,Y] <> F-2) and (Brett[X,Y] <> F) do
  begin
    if not Schlag and (G = 1) and (Brett[X,Y] = 0) then
    begin
      Dam_Zug(T,I,J,X,Y,Zuege)
    end
    else if (X > 0) and (Y < 7) and ((Brett[X,Y] = R) or (Brett[X,Y] = Rd)) then
         begin
           if Brett[X-1,Y+1] <> 0 then X:=-5
           else
           begin
             New_Zug(G,T,I,J,Zuege,Schlag);
             Copy_Zug(G,St,T,Zuege);
             Zuege[T,G].X:=X-1;
             Zuege[T,G].Y:=Y+1;
             Zuege[T,G+1].X:=-1;
             Z:=Brett[X,Y];
             Brett[X,Y]:=0;
             Test_Dame(F,X-1,Y+1,G+1,T,Zuege,Schlag);
             Brett[X,Y]:=Z;
             St:=succ(St);
             X:=-5
           end
         end;
    X:=pred(X); Y:=succ(Y)
  end;
  X:=I-1; Y:=J-1;
  while (X >= 0) and (Y >= 0) and (Brett[X,Y] <> F-2) and (Brett[X,Y] <> F) do
  begin
    if not Schlag and (G = 1) and (Brett[X,Y] = 0) then
    begin
      Dam_Zug(T,I,J,X,Y,Zuege)
    end
    else if (X > 0) and (Y > 0) and ((Brett[X,Y] = R) or (Brett[X,Y] = Rd)) then
         begin
           if Brett[X-1,Y-1] <> 0 then X:=-5
           else
           begin
             New_Zug(G,T,I,J,Zuege,Schlag);
             Copy_Zug(G,St,T,Zuege);
             Zuege[T,G].X:=X-1;
             Zuege[T,G].Y:=Y-1;
             Zuege[T,G+1].X:=-1;
             Z:=Brett[X,Y];
             Brett[X,Y]:=0;
             Test_Dame(F,X-1,Y-1,G+1,T,Zuege,Schlag);
             Brett[X,Y]:=Z;
             St:=succ(St);
             X:=-5
           end
         end;
    X:=pred(X); Y:=pred(Y)
  end;
  if G = 1 then Brett[I,J]:=F
end;

procedure Test_Zug(F,I,J,G :integer; var T :integer; var Zuege :Zlist; var Schlag :boolean);
var
  R,Rd,St :integer;
begin
  St:=0;
  R:=1+(F mod 2);
  Rd:=2+R;
  if F = 2 then
  begin
    if (I > 1) and (J > 1)
               and ((Brett[I-1,J-1] = R) or (Brett[I-1,J-1] = Rd))
               and (Brett[I-2,J-2] = 0) then
    begin
      New_Zug(G,T,I,J,Zuege,Schlag);
      Zuege[T,G].X:=I-2;
      Zuege[T,G].Y:=J-2;
      Zuege[T,G+1].X:=-1;
      Test_Zug(F,I-2,J-2,G+1,T,Zuege,Schlag);
      St:=1
    end;
    if not Schlag and (G = 1) and (I > 0) and (J > 0) and (Brett[I-1,J-1] = 0) then
    begin
      T:=succ(T);
      Zuege[T,0].X:=I;
      Zuege[T,0].Y:=J;
      Zuege[T,G].X:=I-1;
      Zuege[T,G].Y:=J-1;
      Zuege[T,G+1].X:=-1
    end;
    if (I > 1) and (J < 6)
               and ((Brett[I-1,J+1] = R) or (Brett[I-1,J+1] = Rd))
               and (Brett[I-2,J+2] = 0) then
    begin
      New_Zug(G,T,I,J,Zuege,Schlag);
      Copy_Zug(G,St,T,Zuege);
      Zuege[T,G].X:=I-2;
      Zuege[T,G].Y:=J+2;
      Zuege[T,G+1].X:=-1;
      Test_Zug(F,I-2,J+2,G+1,T,Zuege,Schlag)
    end;
    if not Schlag and (G = 1) and (I > 0) and (J < 7) and (Brett[I-1,J+1] = 0) then
    begin
      T:=succ(T);
      Zuege[T,0].X:=I;
      Zuege[T,0].Y:=J;
      Zuege[T,G].X:=I-1;
      Zuege[T,G].Y:=J+1;
      Zuege[T,G+1].X:=-1
    end
  end
  else
  begin
    if (I < 6) and (J > 1)
               and ((Brett[I+1,J-1] = R) or (Brett[I+1,J-1] = Rd))
               and (Brett[I+2,J-2] = 0) then
    begin
      New_Zug(G,T,I,J,Zuege,Schlag);
      Zuege[T,G].X:=I+2;
      Zuege[T,G].Y:=J-2;
      Zuege[T,G+1].X:=-1;
      Test_Zug(F,I+2,J-2,G+1,T,Zuege,Schlag);
      St:=1
    end;
    if not Schlag and (G = 1) and (I < 7) and (J > 0) and (Brett[I+1,J-1] = 0) then
    begin
      T:=succ(T);
      Zuege[T,0].X:=I;
      Zuege[T,0].Y:=J;
      Zuege[T,G].X:=I+1;
      Zuege[T,G].Y:=J-1;
      Zuege[T,G+1].X:=-1
    end;
    if (I < 6) and (J < 6)
               and ((Brett[I+1,J+1] = R) or (Brett[I+1,J+1] = Rd))
               and (Brett[I+2,J+2] = 0) then
    begin
      New_Zug(G,T,I,J,Zuege,Schlag);
      Copy_Zug(G,St,T,Zuege);
      Zuege[T,G].X:=I+2;
      Zuege[T,G].Y:=J+2;
      Zuege[T,G+1].X:=-1;
      Test_Zug(F,I+2,J+2,G+1,T,Zuege,Schlag)
    end;
    if not Schlag and (G = 1) and (I < 7) and (J < 7) and (Brett[I+1,J+1] = 0) then
    begin
      T:=succ(T);
      Zuege[T,0].X:=I;
      Zuege[T,0].Y:=J;
      Zuege[T,G].X:=I+1;
      Zuege[T,G].Y:=J+1;
      Zuege[T,G+1].X:=-1
    end
  end
end;
{$A+}

function Bewertung(F,T :integer):integer;
var
  I,J,St,Be :integer;
begin
  I:=0; Be:=0; St:=0;
  while I <= 7 do
  begin
    J:=1-(I mod 2);
    while J <= 7 do
    begin
      if Brett[I,J] = F then
      begin
        St:=succ(St);
        Be:=Be+Stein[F,I]
      end
      else if Brett[I,J] = F+2 then
           begin
             Be:=Be+(Da_wert-St_wert);
             St:=succ(St)
           end;
      J:=J+2
    end;
    I:=succ(I)
  end;
  if (St = 0) or (T = -1) then Be:=-1000
  else
  begin
    Be:=Be+St_wert*St;
    Be:=Be+T*Zu_wert
  end;
  Bewertung:=Be
end;

{$A-}
function Zug(Stufe,Farbe,Alpha,Beta,Ts,Tss :integer):integer;
var
  T,I,J,R,Rd,Zx,Zy,Z,
  Akzug,Mzug          :integer;
  Zuege               :Zlist;
  Hr                  :array[0..Maxzt] of integer;
  Schlag,First        :boolean;
begin
  gotoxy(1,13);
  writeln('Gesamt : ',Ges_anz:10);
  Ges_anz:=succ(Ges_anz);
  if Stufe > 0 then
  begin
    I:=0;
    R:=1+(Farbe mod 2);
    Rd:=2+R;
    T:=-1;
    Schlag:=false;
    First:=false;
    while I <= 7 do
    begin
      J:=1-(I mod 2);
      while J <= 7 do
      begin
        if Brett[I,J] = Farbe then Test_Zug(Farbe,I,J,1,T,Zuege,Schlag);
        if Brett[I,J] = 2+Farbe then Test_Dame(2+Farbe,I,J,1,T,Zuege,Schlag);
        if Schlag and not First then
        begin
          T:=-1;
          I:=-1;
          J:=10;
          First:=true
        end;
        J:=J+2
      end;
      I:=succ(I)
    end;
    if (T = -1) and (Stufe = Start) then
    begin
      Verl:=Amz;
      exit
    end;
    I:=0;
    if Amz = Farbe then Mzug:=-1000 else Mzug:=1000;
    while I <= T do
    begin
      Z:=Brett[Zuege[I,0].X,Zuege[I,0].Y];
      J:=1;
      while Zuege[I,J].X <> -1 do
      begin
        if Zuege[I,J].X > Zuege[I,J-1].X then Zx:=Zuege[I,J].X-1 else Zx:=Zuege[I,J].X+1;
        if Zuege[I,J].Y > Zuege[I,J-1].Y then Zy:=Zuege[I,J].Y-1 else Zy:=Zuege[I,J].Y+1;
        Hr[J-1]:=Brett[Zx,Zy];
        Brett[Zuege[I,J-1].X,Zuege[I,J-1].Y]:=0;
        Brett[Zuege[I,J].X,Zuege[I,J].Y]:=Z;
        Brett[Zx,Zy]:=0;
        J:=succ(J)
      end;
      Akzug:=Zug(Stufe-1,R,Alpha,Beta,T,Ts);
      J:=pred(J);
      while J > 0 do
      begin
        if Zuege[I,J].X > Zuege[I,J-1].X then Zx:=Zuege[I,J].X-1 else Zx:=Zuege[I,J].X+1;
        if Zuege[I,J].Y > Zuege[I,J-1].Y then Zy:=Zuege[I,J].Y-1 else Zy:=Zuege[I,J].Y+1;
        Brett[Zuege[I,J-1].X,Zuege[I,J-1].Y]:=Z;
        Brett[Zuege[I,J].X,Zuege[I,J].Y]:=0;
        Brett[Zx,Zy]:=Hr[J-1];
        J:=pred(J)
      end;
      if Amz = Farbe then
      begin
        if Akzug > Mzug then
        begin
          Mzug:=Akzug;
          if Stufe = Start then Mi:=Zuege[I]
        end;
        if (Akzug = Mzug) and (Random(2) = 0) then
        begin
          Mzug:=Akzug;
          if Stufe = Start then Mi:=Zuege[I]
        end;
        if Mzug > Alpha then Alpha:=Mzug;
        if (Stufe <> Start) and (Mzug > Beta) then
        begin
          Beta_anz:=succ(Beta_anz);
          I:=50
        end
      end
      else
      begin
        if Akzug < Mzug then
        begin
          Mzug:=Akzug;
          if Stufe = Start then Mi:=Zuege[I]
        end;
        if (Akzug = Mzug) and (Random(2) = 0) then
        begin
          Mzug:=Akzug;
          if Stufe = Start then Mi:=Zuege[I]
        end;
        if Mzug < Beta then Beta:=Mzug;
        if (Stufe <> Start) and (Mzug < Alpha) then
        begin
          Alpha_anz:=succ(Alpha_anz);
          I:=50
        end
      end;
      I:=succ(I)
    end
  end
  else
  begin
    if Amz = Farbe then
    begin
      Mzug:=Bewertung(Amz,Tss);
      Mzug:=Mzug-Bewertung(1+(Amz mod 2),Ts)
    end
    else
    begin
      Mzug:=Bewertung(Amz,Ts);
      Mzug:=Mzug-Bewertung(1+(Amz mod 2),Tss)
    end
  end;
  Zug:=Mzug
end;
{$A+}

procedure Make_Zug;
var
  J,R,Z,Zx,Zy :integer;
begin
  Z:=Brett[Mi[0].X,Mi[0].Y];
  if Z <> 0 then
  begin
    J:=1;
    while Mi[J].X <> -1 do
    begin
      if Mi[J].X > Mi[J-1].X then Zx:=Mi[J].X-1 else Zx:=Mi[J].X+1;
      if Mi[J].Y > Mi[J-1].Y then Zy:=Mi[J].Y-1 else Zy:=Mi[J].Y+1;
      Brett[Mi[J-1].X,Mi[J-1].Y]:=0;
      Brett[Mi[J].X,Mi[J].Y]:=Z;
      Ch_to_Dame(Mi[J].X,Mi[J].Y);
      Brett[Zx,Zy]:=0;
      J:=succ(J)
    end;
    Out_Brett
  end
  else Verl:=Amz
end;

procedure Spieler;
var
  I,J     :integer;
  Lastkey :char;
  H       :Sp_br;
begin
  Cur_Off;
  gotoxy(1,11); writeln('Sie sind am Zug .....');
  H:=Brett;
  repeat
    gotoxy(5+3*Xp,2+Yp); write('*');
    repeat
      read(kbd,Lastkey);
      case Lastkey of
        #5  :if Yp > 0 then
             begin
               Xap:=Xp;
               Yap:=Yp;
               Yp:=pred(Yp)
             end;
        #19 :if Xp > 0 then
             begin
               Xap:=Xp;
               Yap:=Yp;
               Xp:=pred(Xp)
             end;
        #4  :if Xp < 7 then
             begin
               Xap:=Xp;
               Yap:=Yp;
               Xp:=succ(Xp)
             end;
        #24 :if Yp < 7 then
             begin
               Xap:=Xp;
               Yap:=Yp;
               Yp:=succ(Yp)
             end;
        #7  :Brett[Yp,Xp]:=1;
        #20 :Brett[Yp,Xp]:=3;
        #25 :Brett[Yp,Xp]:=0
      end;
      gotoxy(5+3*Xap,2+Yap);
      if (Xap+Yap) mod 2 =1 then normvideo;
      if (Brett[Yap,Xap] mod 2 = 1) and (Brett[Yap,Xap] <> 0) then lowvideo;
      if Brett[Yap,Xap] > 2 then write('x')
      else if Brett[Yap,Xap] = 0 then write(' ') else write('o');
      lowvideo;
      gotoxy(5+3*Xp,2+Yp); write('*')
    until (Lastkey = #13) or (Lastkey = #27);
    if Lastkey = #27 then Brett:=H;
    Out_Brett
  until Lastkey = #13;
  Cur_On
end;

function Check_Zug:boolean;
var
  I,J   :integer;
  Check :boolean;
begin
  Check:=false;
  I:=0;
  while not Check and (I <= 7) do
  begin
    J:=1-(I mod 2);
    while not Check and (J <= 7) do
    begin
      if (Brett[I,J] = 1) and (I < 7) then
      begin
        if (J < 7) and (Brett[I+1,J+1] = 0) then Check:=true;
        if (I < 7) and (J > 0) and (Brett[I+1,J-1] = 0) then Check:=true;
        if (I < 6) and (J > 1) and ((Brett[I+1,J-1] = 2) or (Brett[I+1,J-1] = 4))
                               and (Brett[I+2,J-2] = 0) then Check:=true;
        if (I < 6) and (J < 6) and ((Brett[I+1,J+1] = 2) or (Brett[I+1,J+1] = 4))
                               and (Brett[I+2,J+2] = 0) then Check:=true
      end;
      if not Check and (Brett[I,J] = 3) then
      begin
        if (I < 7) and (J < 7) and (Brett[I+1,J+1] = 0) then Check:=true;
        if (I < 7) and (J > 0) and (Brett[I+1,J-1] = 0) then Check:=true;
        if (I > 0) and (J < 7) and (Brett[I-1,J+1] = 0) then Check:=true;
        if (I > 0) and (J > 0) and (Brett[I-1,J-1] = 0) then Check:=true;
        if (I < 6) and (J < 6) and ((Brett[I+1,J+1] = 2) or (Brett[I+1,J+1] = 4))
                               and (Brett[I+2,J+2] = 0) then Check:=true;
        if (I < 6) and (J > 1) and ((Brett[I+1,J-1] = 2) or (Brett[I+1,J-1] = 4))
                               and (Brett[I+2,J-2] = 0) then Check:=true;
        if (I > 1) and (J < 6) and ((Brett[I-1,J+1] = 2) or (Brett[I-1,J+1] = 4))
                               and (Brett[I-2,J+2] = 0) then Check:=true;
        if (I > 1) and (J > 1) and ((Brett[I-1,J-1] = 2) or (Brett[I-1,J-1] = 4))
                               and (Brett[I-2,J-2] = 0) then Check:=true
      end;
      J:=succ(J)
    end;
    I:=succ(I)
  end;
  Check_Zug:=Check
end;

begin
  Set_Rub;
  clrscr;
  writeln('Bitte geben Sie jetzt die gewuenschte Spielstaerke ein : ');
  readln(Start);
  if (Start > 5) or (Start < 1) then Start:=DefStart;
  clrscr;
  Xp:=0; Yp:=0;
  Xap:=Xp; Yap:=Yp;
  Verl:=0;
  Amz:=2;
  Set_Brett;
  Out_Brett;
  randomize;
  while Verl = 0 do
  begin
    gotoxy(1,11); writeln('Ich ueberlege ........');
    Ges_anz:=0;
    Za:=Zug(Start,Amz,-5000,5000,8,8);
    gotoxy(1,17); writeln('Bewertung = ',Za:6);
    Make_Zug;
    if Gegner = 1 then Amz:=1+(Amz mod 2)
    else
    begin
      if Verl = 0 then
        if Check_Zug then Spieler
        else Verl:=1
    end
  end;
  if Verl = 1 then writeln('Es tut mir leid, Sie haben verloren')
  else writeln('Ich muss zugeben, Sie sind hier das denkende Wesen');
  read(kbd,C);
  clrscr
end.
