Program Single_Drive_Kopierer;


Const    BlockSpeicher = 250;
         ByteSpeicher  = 32000;

Var      Quelle, Ziel                           : File;
         Speicher                               : Array[1..ByteSpeicher] of Byte;
         ZuKopierendeBlocks, Blockzahl          : Integer;
         ErsteQuelle, ErstesZiel, FileGefunden,
         SchonDa, Ja, Stop                      : Boolean;
         AltName, NeuName                       : String[14];


Procedure LiesNamen;

Begin
  Repeat
    GotoXY(4,10);
    Write('Eingabe des Quelldateinamens :  ');
    ClrEol;
    Read(AltName)
  Until AltName <> '';

  GotoXY(4,12);
  Write('Eingabe des Zieldateinamens :   ');
  ClrEol;
  Read(NeuName);

  If NeuName = '' then
  Begin
    NeuName := AltName;
    Write(NeuName)
  End;

  Assign(Quelle,AltName);
  Assign(Ziel,NeuName)
End;


Procedure HoleTaste;

Var      Taste  : Char;

Begin
  Repeat
  Until Keypressed;
  Read(KBD,Taste);
  Stop := (Taste = #27);
  Ja := (Taste in ['j','J','y','Y'])
End;


(* Main *)

Begin
  Repeat                             (* Noch eine Datei? *)
    ClrScr;
    GotoXY(43,2);
    Write('SDC 2.1');
    GotoXY(27,3);
    Write('CP/M 3.0 single drive file copy program');
    GotoXY(32,4);
    Write('written 1986');

    Repeat                           (* Bis Datei gefunden *)
      Stop := False;
      Blockzahl := 1;
      ErsteQuelle := True;
                                     (* Kopiere bis Datei komplett oder User Stop *)

      While (Blockzahl > 0) and (Not Stop) do
      Begin
        If ErsteQuelle then
        LiesNamen;
        GotoXY(4,18);
        Write('Einlegen Quelldisk und Taste druecken ');
        ClrEol;
        HoleTaste;
        If Not Stop then             (* User Stop 1 *)
        Begin
          If ErsteQuelle then
          Begin
            (*$I-*)
            Reset(Quelle);
            FileGefunden := (IOResult = 0);
            ErsteQuelle := False;
            Blockzahl := FileSize(Quelle)
            (*$I+*)
          End;
          If Not FileGefunden then
          Begin
            GotoXY(4,18);
            Blockzahl := 0;
            Write(AltName,' nicht gefunden!',^G);
            ClrEol
          End
          Else                       (* Alles OK, es kann gelesen werden *)
          Begin
            GotoXY(23,16);
            Write('Anzahl der zu kopierenden Records = ',Blockzahl : 6);
            If Blockzahl > BlockSpeicher then
              ZuKopierendeBlocks := BlockSpeicher
            Else
              ZuKopierendeBlocks := Blockzahl;
            BlockRead(Quelle,Speicher,ZuKopierendeBlocks);
            GotoXY(1,18);
            ClrEol;
            GotoXY(4,18);
            Write('Einlegen Zieldisk und Taste druecken ');
            HoleTaste;
            If Not Stop then         (* User Stop 2 *)
            Begin
              If ErstesZiel then
                (*$I-*)
                Reset(Ziel);
                (*$I+*)
                SchonDa := (IOResult = 0);
                If SchonDa then
                Begin
                  GotoXY(4,22);
                  Write(NeuName,' existiert bereits, trotzdem kopieren? ',^G);
                  ClrEol;
                  HoleTaste;
                  GotoXY(4,22);
                  ClrEol
                End;
                If Ja or Not SchonDa then
                                     (* Alles OK, kann geschrieben werden *)
                Begin
                  If ErstesZiel then
                  Begin
                    Rewrite(Ziel);
                    ErstesZiel := False
                  End
                  Else
                    Stop := True
                End;
                If Not Stop then
                Begin
                  Reset(Ziel);
                  Seek(Ziel,FileSize(Ziel));
                  BlockWrite(Ziel,Speicher,ZuKopierendeBlocks);
                  Close(Ziel);
                  Blockzahl := Blockzahl-ZuKopierendeBlocks
                End
            End
          End
        End
      End
    Until FileGefunden or Stop;
    GotoXY(4,22);
    ClrEol;
    Write('Noch eine Kopie? ');
    HoleTaste;
  Until Not Ja;
  ClrScr;
  Writeln('Ende des Kopierens')
End.
